import blobDetection.*;
import processing.opengl.*;
import processing.video.*; 

Capture myCapture; 

//globals for blob detection
PImage img;
PImage LrgImg;
BlobDetection theBlobDetection;
boolean newFrame=false;
boolean newFunction=true;

int iBiggestBlobSoFar;
float fLargestBlobSoFar;
float fLargestBlobWidth;
float fLargestBlobHeight;
float fLargestBlobXpos;
float fLargestBlobYpos;
float fThisSize;
float fLastSize;
boolean bCaptureStartSize=false;
float fCapturedStartSize;
float fSpacingAdjust;
float fRotationFactor =0.0;

int BlockSize=16;
int BlockSizeOffset;
int BlockGroupSize;
int LookAtXpos;
int LookAtYpos;
color DefCol = color (255,255,200,240);


// applet size variables
int xSize           = 1024;//512;//
int ySize           = 768;//384;//
int iPixelsSize;
float fIntitialSpacing;

//number of objects in class array  
int iNum = 2;
float fLargeOrbitRadius=135;
float fMoonSpacing=25;
float fPlanetReference;

//declare array of objects
ThePlanets[] PlanetObjects = new ThePlanets[iNum];






void setup() 
{
  size(xSize,ySize, OPENGL);
  
  // List all available capture devices to the console
  // Use the information printed to the text area to
  // correctly set the variable "s" below
  println(Capture.list());

  // Specify your own device by the name of the capture
  // device returned from the Capture.list() function

  String s = "IIDC FireWire Video";
  myCapture = new Capture(this, s, width, height, 30); 
  
  //blob detection
  iBiggestBlobSoFar=0;
  fLargestBlobSoFar=0.0;
  fThisSize=0.0;
  fLastSize=0.0;
  iPixelsSize=width*height;
  
  BlockGroupSize=((width/BlockSize)*(height/BlockSize));
  BlockSizeOffset=BlockSize/2;
  
  println(iPixelsSize);
  println(BlockGroupSize);
   
  LrgImg = new PImage(width,height);
  img = new PImage(80,60); // img which will be sent to detection (a smaller copy of the cam frame);
  theBlobDetection = new BlobDetection(img.width, img.height);
  theBlobDetection.setPosDiscrimination(true);
  theBlobDetection.setThreshold(0.9f); // will detect bright areas whose luminosity > 0.2f;
  
  //fill array of objects using "New" using a for() loop
  for (int i=0;i<iNum;i++)
  {
    PlanetObjects[i]= new ThePlanets(0.0,0.0,0.0, 45.0, 10,0.1 ,0.1 ,0 , 0, 0, DefCol,true,true);
    if(i!=0)
    {
      PlanetObjects[i].mother=false;
      PlanetObjects[i].radius=PlanetObjects[0].radius/2.5;
      fPlanetReference=PlanetObjects[0].radius/5.5;
      PlanetObjects[i].xpos=fLargeOrbitRadius;
    }
  }
}

void captureEvent(Capture myCapture) 
{ 
  myCapture.read(); 
  newFrame = true;
} 

void draw() 
{ 
     if (newFrame)
    {
  
        fLastSize=fThisSize;
        background(0);
        newFrame=false;
       
        LookAtXpos = int(fLargestBlobXpos+(fLargestBlobWidth/2));
        LookAtYpos= int(fLargestBlobYpos+(fLargestBlobHeight/2));

       for( int a = 0; a <iPixelsSize ; a++) 
       { 

         int iRow = a/width;
         int iColumn= a%width;
     
         int InterimPixelValue;//for rows
         int AdditionalPixelValue;//for column
         int FinalPixelValue;//for combined
          
         if ((iRow%BlockSize)==0 )
         {
             if((iColumn%BlockSize)==0) //check to see if row is fits into blocks of 8 - or whatever vlaue block size is set to
             {

                 int intSampleRow=iRow+(BlockSize/2);//adds half a block to centre in Y axis
                       
                 if((intSampleRow*width)<iPixelsSize)
                 {
                     float temp;
           
                     InterimPixelValue=intSampleRow*width;
                     AdditionalPixelValue=iColumn+(BlockSize/2);
                     FinalPixelValue=InterimPixelValue+AdditionalPixelValue;
                     color c = myCapture.pixels[FinalPixelValue];
           
                     // temp = ((red(c)*0.2125)+(green(c)*0.7154)+(blue(c)*0.0721));//creates float value for grayscale           
                    // color bw=(int)(255-temp);//negative
                     //color bw=(int)(temp);//positive
                  
                    //-----------------------------------------------------------------------------------------------------------------------
                    float angle;
                    int PosBlockX, PosBlockY;//create values for block position
                    PosBlockX=(width-(iColumn+BlockSize))+BlockSizeOffset;//assign them to make calculations more transparent
                    PosBlockY=iRow+BlockSizeOffset;//assign them to make calculations more transparent
                    
                    angle = atan2(PosBlockY- LookAtYpos,PosBlockX- LookAtXpos); //calculate angle for blocks                
                 
                   
                    pushMatrix(); //save matrix----------------------------------------------------------------
                    noFill();
                   //fill(c);
                    noStroke();
                    rectMode(CENTER);//FIX FOR CUTTOING OF BORDERS achieved using BlockSizeOffset
                    // Changes the position from which shapes will draw..... 
                    translate(  (width-(iColumn+BlockSize))+BlockSizeOffset, (iRow+BlockSizeOffset),-70); 
                    rect(0, 0, BlockSize, BlockSize); //.....in effect a dummy object to carry translate
                    
//                  scale(ScalingFactor);
                    
                    fill(c);// prepare 'real' object with colour taken from video
                    //fill(red(c),green(c),blue(c),100);//for alpha blending
                    rotate(angle); 
                    rotateZ(angle);
                    rotateY(angle);
                    rect(0, 0, BlockSize, BlockSize); 
                    //println(PlanetObjects[1].zpos); only gives input value
                
                    
                    popMatrix(); //bring back matrix for next round-------------------------------------------------
                    // resetMatrix(); //zero matrix for next turn....may be overkill as also seems to work without!!

         
//                  smooth();
                 }
            }
        } 
  }
        img.copy(myCapture, 0, 0, myCapture.width, myCapture.height, 0, 0, img.width, img.height);
        fastblur(img, 2);
        theBlobDetection.computeBlobs(img.pixels);
        img.updatePixels();
        drawBlobsAndEdges(true);
    
        PlanetObjects[0].xpos = int(fLargestBlobXpos+(fLargestBlobWidth/2));//****************************************************************
        PlanetObjects[0].ypos= int(fLargestBlobYpos+(fLargestBlobHeight/2));//****************************************************************
          
         // PlanetObjects[0].xpos=width/2;
         // PlanetObjects[0].ypos=height/2;
          
        if(fLargestBlobHeight>=fLargestBlobWidth)
        {
            fIntitialSpacing=fLargestBlobHeight/2;
           }else{
           fIntitialSpacing=fLargestBlobWidth/2;
        }

     
        PlanetObjects[0].detail=20; 
        PlanetObjects[1].radius=fPlanetReference*fSpacingAdjust;
        PlanetObjects[0].radius=int(fIntitialSpacing); //**********************************************************************************
        
        if((bCaptureStartSize==false)&&(fIntitialSpacing>0))
        {
          fCapturedStartSize=fIntitialSpacing;
          println("fCapturedStartSize");
          println(fCapturedStartSize);
          bCaptureStartSize=true;
        }
        
        fSpacingAdjust=fIntitialSpacing/fCapturedStartSize;

      
        pushMatrix();
        //scale(fSpacingAdjust);
        //PlanetObjects[0].zpos=0;
        for(int i=0;i<iNum;i++)
        {
           
          if(i!=0)
          {

            PlanetObjects[i].xpos=fLargeOrbitRadius*fSpacingAdjust;
//            PlanetObjects[i].radius=fLargeOrbitRadius*fSpacingAdjust;
          }
          
          PlanetObjects[i].MovingSpining();
          PlanetObjects[i].PlaceOnScreen();
            
          }
          popMatrix();
        }

}

